package body MSHTML.HTMLAnchorEvents_Events is

   procedure Invoke
     (dispidMember : in Interfaces.C.long;
      wFlags       : in Interfaces.C.unsigned_short;
      pdispparams  : in GNATCOM.Types.Pointer_To_DISPPARAMS;
      Event_Object : in GNATCOM.Events.Event_Object.Event_Pointer)
   is
      use type Interfaces.C.long;
   begin
      case dispidMember is
         when HTMLAnchorEvents_onhelp=>
            onhelp
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onclick=>
            onclick
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_ondblclick=>
            ondblclick
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onkeypress=>
            onkeypress
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onkeydown=>
            onkeydown
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onkeyup=>
            onkeyup
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onmouseout=>
            onmouseout
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onmouseover=>
            onmouseover
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onmousemove=>
            onmousemove
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onmousedown=>
            onmousedown
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onmouseup=>
            onmouseup
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onselectstart=>
            onselectstart
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onfilterchange=>
            onfilterchange
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_ondragstart=>
            ondragstart
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onbeforeupdate=>
            onbeforeupdate
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onafterupdate=>
            onafterupdate
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onerrorupdate=>
            onerrorupdate
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onrowexit=>
            onrowexit
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onrowenter=>
            onrowenter
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_ondatasetchanged=>
            ondatasetchanged
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_ondataavailable=>
            ondataavailable
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_ondatasetcomplete=>
            ondatasetcomplete
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onlosecapture=>
            onlosecapture
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onpropertychange=>
            onpropertychange
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onscroll=>
            onscroll
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onfocus=>
            onfocus
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onblur=>
            onblur
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onresize=>
            onresize
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_ondrag=>
            ondrag
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_ondragend=>
            ondragend
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_ondragenter=>
            ondragenter
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_ondragover=>
            ondragover
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_ondragleave=>
            ondragleave
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_ondrop=>
            ondrop
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onbeforecut=>
            onbeforecut
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_oncut=>
            oncut
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onbeforecopy=>
            onbeforecopy
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_oncopy=>
            oncopy
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onbeforepaste=>
            onbeforepaste
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onpaste=>
            onpaste
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_oncontextmenu=>
            oncontextmenu
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onrowsdelete=>
            onrowsdelete
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onrowsinserted=>
            onrowsinserted
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_oncellchange=>
            oncellchange
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onreadystatechange=>
            onreadystatechange
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onbeforeeditfocus=>
            onbeforeeditfocus
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onlayoutcomplete=>
            onlayoutcomplete
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onpage=>
            onpage
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onbeforedeactivate=>
            onbeforedeactivate
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onbeforeactivate=>
            onbeforeactivate
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onmove=>
            onmove
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_oncontrolselect=>
            oncontrolselect
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onmovestart=>
            onmovestart
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onmoveend=>
            onmoveend
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onresizestart=>
            onresizestart
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onresizeend=>
            onresizeend
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onmouseenter=>
            onmouseenter
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onmouseleave=>
            onmouseleave
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onmousewheel=>
            onmousewheel
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onactivate=>
            onactivate
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_ondeactivate=>
            ondeactivate
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onfocusin=>
            onfocusin
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when HTMLAnchorEvents_onfocusout=>
            onfocusout
              (HTMLAnchorEvents_Event'Class (Event_Object.all));
         when others =>
            null;
      end case;
   end Invoke;

   function Create (From : in GNATCOM.Events.Event_Object.Event_Pointer)
     return GNATCOM.Create.COM_Interface.Pointer_To_COM_Interface_Type
   is
   begin
      return GNATCOM.Events.Event_Object.Create
        (Invoke'Access,
         IID_HTMLAnchorEvents,
         From);
   end Create;

   procedure Set_Events
     (This            : in out GNATCOM.Events.IConnectionPoint_Type;
      For_Object      : in     GNATCOM.IInterface.Interface_Type'Class;
      Event_Interface :
        access GNATCOM.Create.COM_Interface.COM_Interface_Type;
      Free            : Boolean := True)
   is
   begin
      GNATCOM.Events.Set_Events
        (This,
         For_Object,
         IID_HTMLAnchorEvents,
         Event_Interface,
         Free);
   end Set_Events;

   procedure onhelp
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onhelp;

   procedure onclick
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onclick;

   procedure ondblclick
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end ondblclick;

   procedure onkeypress
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onkeypress;

   procedure onkeydown
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onkeydown;

   procedure onkeyup
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onkeyup;

   procedure onmouseout
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onmouseout;

   procedure onmouseover
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onmouseover;

   procedure onmousemove
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onmousemove;

   procedure onmousedown
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onmousedown;

   procedure onmouseup
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onmouseup;

   procedure onselectstart
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onselectstart;

   procedure onfilterchange
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onfilterchange;

   procedure ondragstart
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end ondragstart;

   procedure onbeforeupdate
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onbeforeupdate;

   procedure onafterupdate
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onafterupdate;

   procedure onerrorupdate
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onerrorupdate;

   procedure onrowexit
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onrowexit;

   procedure onrowenter
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onrowenter;

   procedure ondatasetchanged
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end ondatasetchanged;

   procedure ondataavailable
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end ondataavailable;

   procedure ondatasetcomplete
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end ondatasetcomplete;

   procedure onlosecapture
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onlosecapture;

   procedure onpropertychange
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onpropertychange;

   procedure onscroll
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onscroll;

   procedure onfocus
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onfocus;

   procedure onblur
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onblur;

   procedure onresize
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onresize;

   procedure ondrag
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end ondrag;

   procedure ondragend
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end ondragend;

   procedure ondragenter
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end ondragenter;

   procedure ondragover
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end ondragover;

   procedure ondragleave
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end ondragleave;

   procedure ondrop
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end ondrop;

   procedure onbeforecut
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onbeforecut;

   procedure oncut
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end oncut;

   procedure onbeforecopy
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onbeforecopy;

   procedure oncopy
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end oncopy;

   procedure onbeforepaste
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onbeforepaste;

   procedure onpaste
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onpaste;

   procedure oncontextmenu
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end oncontextmenu;

   procedure onrowsdelete
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onrowsdelete;

   procedure onrowsinserted
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onrowsinserted;

   procedure oncellchange
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end oncellchange;

   procedure onreadystatechange
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onreadystatechange;

   procedure onbeforeeditfocus
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onbeforeeditfocus;

   procedure onlayoutcomplete
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onlayoutcomplete;

   procedure onpage
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onpage;

   procedure onbeforedeactivate
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onbeforedeactivate;

   procedure onbeforeactivate
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onbeforeactivate;

   procedure onmove
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onmove;

   procedure oncontrolselect
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end oncontrolselect;

   procedure onmovestart
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onmovestart;

   procedure onmoveend
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onmoveend;

   procedure onresizestart
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onresizestart;

   procedure onresizeend
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onresizeend;

   procedure onmouseenter
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onmouseenter;

   procedure onmouseleave
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onmouseleave;

   procedure onmousewheel
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onmousewheel;

   procedure onactivate
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onactivate;

   procedure ondeactivate
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end ondeactivate;

   procedure onfocusin
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onfocusin;

   procedure onfocusout
     (This : HTMLAnchorEvents_Event)
   is
   begin
      null;
   end onfocusout;

end MSHTML.HTMLAnchorEvents_Events;

